package w5.ex1.timings.ex;

import java.io.*;
import java.util.*;

public class Timings2 {

	public static void main(String[] args) {
		// Use different implementations of a collection
		Collection<Integer>[] colls = new Collection[4];
		colls[0] = new TreeSet<Integer>();
		colls[1] = new HashSet<Integer>();
		colls[2] = new LinkedList<Integer>();
		colls[3] = new ArrayList<Integer>();

		final int NUMRUNS = Integer.parseInt(args[0]);
		final int SEED = Integer.parseInt(args[1]);

		for (Collection<Integer> c : colls) {
			Random randomizer = new Random(SEED);
			// Add a lot...
			long now = System.nanoTime();
			for (int i = 0; i < NUMRUNS; i++) {
				c.add(randomizer.nextInt());
			}
			System.out.println("add " + c.getClass() + "\t"
					+ ((System.nanoTime() - now) / 1000000000.0));

			// ...and search a lot
			now = System.nanoTime();
			for (int i = 0; i < NUMRUNS; i++) {
				c.contains(randomizer.nextInt());
			}
			System.out.println("contains " + c.getClass() + "\t"
					+ ((System.nanoTime() - now) / 1000000000.0));
			c.clear();
		}
	}
}
