package w5.ex4.decoratoriterator.ex;

import java.util.Iterator;
import java.util.Collection;
import java.util.LinkedList;

public class ForwardInputIterator<T> implements Iterator<T> {
	private final Iterator<T> it;

	public ForwardInputIterator(final Iterator<T> it) {
		this.it = it;
	}

	@Override
	public boolean hasNext() {
		return this.it.hasNext();
	}

	@Override
	public T next() {
		return this.it.next();
	}

	@Override
	public void remove() {
		throw new UnsupportedOperationException("remove() not supported.");
	}

	/**
	 * @@post What postcondition can this method guarantee with regards
	 *        to the structure that @it@ iterates on?
	 */
	public static <T> void processIterator(Iterator<T> it) {
		// ... do something interesting here.
	}

	/**
	 * @@post What postcondition can this method guarantee with regards
	 *        to the structure that @it@ iterates on?
	 */
	public static <T> void processIterator(ForwardInputIterator<T> it) {
		// ... do something interesting here.
	}

	public static void main(String[] args) {
		Collection<Object> coll = new LinkedList<Object>();
		// ... add a lot of elements to coll.

		// How is this different ...
		processIterator(coll.iterator());

		// From this ...
		processIterator(new ForwardInputIterator<Object>(coll.iterator()));

		// and this ...
		processIterator((Iterator<Object>) new ForwardInputIterator<Object>(
				coll.iterator()));
	}
}